//------------------------------------------------------------------------
//
//  C R A N E . INC
//
//  Author:  Robert J Becraft
//  Created: March, 1998
//------------------------------------------------------------------------
// Crane modules

#declare Crane_Topa=union{
          box{<-1,-.25,-.25><1,.25,.25> texture{Steel_beam}}
          sphere{<-.75,.25,0>,.25 texture{Glow_White}}
//          sphere{<-.50,.25,0>,.25 texture{Glow_Green}}
//          sphere{<-.25,.25,0>,.25 texture{Glow_White}}
          sphere{<0,.25,0>,.25 texture{Glow_Green}}
          sphere{<.75,.25,0>,.25 texture{Glow_Red}}
//          sphere{<.50,.25,0>,.25 texture{Glow_Blue}}
//          sphere{<.25,.25,0>,.25 texture{Glow_Orange}}
}
#declare Crane_Litea=difference{
      union{
            cylinder{<0,-.2,0><0,.2,0>,.2 texture{Steel_beam}}
            sphere{<0,.2,0>,.2 texture{Steel_beam}}
      }
      cylinder{<0,-.21,0><0,.2,0>,.199 texture{silver}}
}
#declare Crane_Lite_Red=union{
    object{Crane_Litea}
    object{Lite_Red}
}
#declare Crane_Lite_Green=union{
    object{Crane_Litea}
    object{Lite_Green}
}
#declare Crane_Lite_Blue=union{
    object{Crane_Litea}
    object{Lite_Blue}
}
#declare Crane_S1=cone{<-.30,-1,-.30>,.2 <1.75,41,1.75>,.1 texture{silver}}
#declare Crane_Tipa=difference{
      union{
          cylinder{<-.35,0,0><.35,0,0>,.4 texture{silver}}
          cylinder{<-.33,0,0><-.31,0,0>,.42 texture{Yellow_Strip}}
          cylinder{<.31,0,0><.33,0,0>,.42 texture{Yellow_Strip}}
          box{<-.35,-.38,-.38><.35,0,.38> texture{silver}}
          box{<-.36,-.39,-.39><.36,-.3,.39> texture{Yellow_Strip}}
       }
       box{<-.30,.2,-1><.30,1,1>}
       box{<-.28,-1,-.28><.28,1,.28>}
       cylinder{<-.36,0,0><.36,0,0>,.1}
}
#declare Crane_Tip=union{
    object{Crane_Tipa texture{silver}}
    cylinder{<-.40,0,0><.40,0,0>,.08 texture{pigment{color Brass}}}
    cylinder{<.03,0,0><.13,0,0>,.3 texture{pigment{color Gray50}}}
    cylinder{<-.13,0,0><-.03,0,0>,.3 texture{pigment{color Gray50}}}
    cylinder{<-.35,.4,0><-.35,.6,0>,.05 texture{Steel_beam}}
    sphere{<-.35,.7,0>,.1 texture{Glow_Red}}
}
#declare Crane_Arm=union{
    object{Crane_S1  rotate<0,0,0> translate<-2,0,-2>}
    object{Crane_S1 rotate<0, 90,0> translate<-2,0,2>}
    object{Crane_S1 rotate<0,-90,0> translate<2,0,-2>}
    object{Crane_S1 rotate<0,180,0> translate<2,0,2>}
    #declare Count=0
    #declare Cwidth=0
    #while (Count<=40)
       cylinder{<-2+Count*1.8/40, Count, 2-Count*1.8/40>  <2-Count*1.8/40, Count+4-Cwidth, 2-Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<-2+Count*1.8/40, Count, 2-Count*1.8/40>  <-2+Count*1.8/40, Count+4-Cwidth, -2+Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<-2+Count*1.8/40, Count, -2+Count*1.8/40> <2-Count*1.8/40, Count+4-Cwidth, -2+Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<-2+Count*1.8/40, Count, -2+Count*1.8/40> <-2+Count*1.8/40, Count+4-Cwidth, 2-Count*1.8/40>,.1-Count*.02/40 texture{silver}}

       cylinder{<2-Count*1.8/40, Count, 2-Count*1.8/40> <-2+Count*1.8/40, Count+4-Cwidth, 2-Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<2-Count*1.8/40, Count, 2-Count*1.8/40> <2-Count*1.8/40, Count+4-Cwidth, -2+Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<2-Count*1.8/40, Count, -2+Count*1.8/40> <2-Count*1.8/40, Count+4-Cwidth, 2-Count*1.8/40>,.1-Count*.02/40 texture{silver}}
       cylinder{<2-Count*1.8/40, Count, -2+Count*1.8/40> <-2+Count*1.8/40, Count+4-Cwidth, -2+Count*1.8/40>,.1-Count*.02/40 texture{silver}}

       #declare Cwidth=Count/20
       #declare Count=Count+4-Cwidth
    #end
    object{Crane_Tip rotate<0,90,0> translate<0,41.5,0> texture{silver} }
}

#declare Crane_Poda=difference{
  union{
      sphere{<0,0,0>,9 texture{silver}}

     object{Pod_Ports}
     object{Pod_Ladder}

      cylinder{<-8.5,0,0><8.5,0,0>,3.8 texture{Yellow_Strip}}
      cylinder{<0,-8.5,0><0,8.5,0>,3.8 texture{Yellow_Strip}}
      cylinder{<0,0,-8.5><0,0,8.5>,3.8 texture{Yellow_Strip}}

      cylinder{<0,0,-6.5><0,0,6.5>,6.6 texture{Yellow_Strip}}
     }
     sphere{<0,0,0>,8.8}  // hollow center
     #declare Count=0
     #while (Count<359)
         sphere{<0,7.2,-5.3>,1.0 rotate<0,0,Count>}
         sphere{<0,7.2,5.3>,1.0  rotate<0,0,Count>}
         #declare Count=Count+20
     #end
}
#declare Crane_Pod=union{
      object{Crane_Poda texture{silver} rotate<90,0,0>}
      cylinder{<0,0,0><0,11,0>,3.3 texture{Steel_beam} finish{Shiny}}

      sphere{<0,15,0>,5 texture{Steel_beam} finish{Shiny}}
      cylinder{<0,14,0><0,16,0>,5.5 texture{Steel_beam}}
      cylinder{<0,14.5,0><0,15,0>,5.8 texture{Steel_beam}}
      cylinder{<0,15.5,0><0,15.8,0>,5.8 texture{Steel_beam}}

      #declare Count=12.25
      #while (Count<359)
           cylinder{<-.1,0,0><.1,0,0>,5.6  rotate<0,Count,> translate<0,15,0> texture{Steel_beam}}
           #declare Count=Count+22.5
      #end


      cylinder{<0,0,0><0,23,0>,2 texture{Steel_beam}}
      cylinder{<0,23,0><0,23.2,0>,2.15 texture{Steel_beam}}
      cylinder{<0,20,0><0,21,0>,2.2 texture{Yellow_Strip}}
      sphere{<0,23,0>,2 texture{Steel_beam}}

      object{Crane_Lite_Red translate<0,23,2.1>}    // mounted on top cap of crane
      object{Crane_Litea translate<-2.1,23,0>}          // lite is off
      object{Crane_Litea translate<2.1,23,0>}           // lite is off
      object{Crane_Topa translate<0,25,0>}            // crosspiece w/ lights

//      object{Girder texture{Steel_beam} rotate<0,0,30> translate<20,28,0>}
         object{Crane_Arm rotate<0,0,-65> translate<0,16,0>}
}
