//------------------------------------------------------------------------
//
//  PARTS . INC
//
//  Author:  Robert J Becraft
//  Created: March, 1998
//------------------------------------------------------------------------
// DEFINE PARTS Used in All  Pods
// Defines
#declare Girder=difference{
   box{<-20,-1,-.25><20,1,.25> texture{Steel_beam}}
   #declare Count=-18
   #while (Count<20)
         cylinder{<Count,0,-.26><Count,0,.26>,.75 }
         #declare Count=Count+2
   #end
   box{<-20.1,-.75,-.26><20.1,.75,-.1>}
   box{<-20.1,-.75,.1><20.1,.75,.26>}
}
#declare Pod_Glazea=difference{
   sphere{<0,0,0>,8.9 texture{Window_Glaze}}
   sphere{<0,0,0>,8.899 texture{Window_Glaze}}
}
#declare Pod_Glaze=object{Pod_Glazea texture{Window_Glaze}}
#declare Hatch=union{
   cylinder{<0,0,0><0,.5,0>,1.55 texture{silver}}
   cylinder{<0,1.5,0><0,1.7,0>,.2 texture{Red_Strip}}
     #declare Count=0
     #while (Count<360)
         cylinder{<1.4,0,0><0,1.6,0>,.1  rotate<0,Count,0> texture{silver}}
         #declare Count=Count+22.5
     #end
}

#declare Port_Lite_Green=union{
      difference{
           cylinder{<-.1,0,0><.1,0,0>,.2 texture{Steel_beam}}
           cylinder{<-.11,0,0><.11,0,0>,.19 texture{silver}}
      }
      sphere{<-.11,0,0>,.19 texture{Glow_Green}}                              // small Green light in fixture
      sphere{<.11,0,0>,.19 texture{Glow_Green}}                              // small Green light in fixture
      cylinder{<0,-.4,0><0,-.2,0>,.1 texture{Steel_beam}}
}
#declare Port_Lite_Orange=union{
      difference{
           cylinder{<-.1,0,0><.1,0,0>,.2 texture{Steel_beam}}
           cylinder{<-.11,0,0><.11,0,0>,.19 texture{silver}}
      }
      sphere{<-.11,0,0>,.19 texture{Glow_Orange}}                              // small Orange light in fixture
      sphere{<.11,0,0>,.19 texture{Glow_Orange}}                              // small Orange light in fixture
      cylinder{<0,-.4,0><0,-.2,0>,.1 texture{Steel_beam}}
}
#declare Port_Lite=union{
      object{Port_Lite_Green translate<0,0,2>}
      object{Port_Lite_Orange translate<0,0,-2>}
}

#declare Pod_Ports=union{
      cylinder{<-11,0,0><11,0,0>,1. texture{Steel_beam}}
      cylinder{<0,-11,0><0,11,0>,1. texture{Steel_beam}}
      cylinder{<0,0,-11><0,0,11>,1. texture{Steel_beam}}

      object{Hatch translate<0,11,0> rotate<0,0,0>}       // top hatch
      object{Port_Lite  translate<0,9.4,0> rotate<0,0,0>}
      object{Hatch translate<0,11,0> rotate<180,0,0>}  // bottom hatch
      object{Port_Lite translate<0,9.4,0> rotate<180,0,0>}
      object{Hatch translate<0,11,0> rotate<90,0,0>}
      object{Port_Lite rotate<0,90,0> translate<0,9.4,0> rotate<90,0,0>}
      object{Hatch translate<0,11,0> rotate<-90,0,0>}
      object{Port_Lite rotate<0,90,0> translate<0,9.4,0> rotate<-90,0,0>}
      object{Hatch translate<0,11,0> rotate<0,0,90>}
      object{Port_Lite translate<0,9.4,0> rotate<0,0,90>}
      object{Hatch translate<0,11,0> rotate<0,0,-90>}
      object{Port_Lite translate<0,9.4,0> rotate<0,0,-90>}

      cylinder{<-9,0,0><9,0,0>,3.5 texture{Steel_beam}}
      cylinder{<0,-9,0><0,9,0>,3.5 texture{Steel_beam}}
      cylinder{<0,0,-9><0,0,9>,3.5 texture{Steel_beam}}
}
#declare Pod_Laddera=union{
      torus{10,.1 translate<0,-.5,0> texture{Steel_beam}}
      torus{10,.1 translate<0,.5,0> texture{Steel_beam}}
     #declare Count=0
     #while (Count<360)
         cylinder{<0,-.5,0><0,.5,0>,.1 translate<10,0,0>  rotate<0,Count,0> texture{Steel_beam}}
         #declare Count=Count+6
     #end
}
#declare Pod_Ladderb=difference{
   union{
        object{Pod_Laddera}
        object{Pod_Laddera rotate<90,0,0>}
        object{Pod_Laddera rotate<0,0,90>}
    }
   box{<-11,-3,-3><11,3,3>}
   box{<-3,-3,-11><3,3,11>}
   box{<-3,-11,-3><3,11,3>}
}
#declare Pod_Ladder_Supports=union{
     torus{3,.1 translate<0,9.5,0> texture{Steel_beam}}
     #declare Count=0
     #while (Count<360)
         cylinder{<0,9,0><0,9.5,0>,.1 translate<3,0,0>  rotate<0,Count,0> texture{Steel_beam}}
         #declare Count=Count+22.5
     #end
}
#declare Pod_Ladder=union{
      object{Pod_Ladderb}
      object{Pod_Ladder_Supports  rotate<0,0,0>}       // top hatch
      object{Pod_Ladder_Supports  rotate<180,0,0>}  // bottom hatch
      object{Pod_Ladder_Supports  rotate<90,0,0>}
      object{Pod_Ladder_Supports  rotate<-90,0,0>}
      object{Pod_Ladder_Supports  rotate<0,0,90>}
      object{Pod_Ladder_Supports  rotate<0,0,-90>}
}

#declare Pod_Ladderc=difference{
   union{
//        object{Pod_Laddera}
        object{Pod_Laddera rotate<90,0,0>}
        object{Pod_Laddera rotate<0,0,90>}
    }
   box{<-11,-3,-3><11,3,3>}
   box{<-3,-3,-11><3,3,11>}
   box{<-3,-11,-3><3,11,3>}
}
#declare Pod_LadderT=union{
      object{Pod_Ladderc}
      object{Pod_Ladder_Supports  rotate<0,0,0>}       // top hatch
      object{Pod_Ladder_Supports  rotate<180,0,0>}  // bottom hatch
      object{Pod_Ladder_Supports  rotate<90,0,0>}
      object{Pod_Ladder_Supports  rotate<-90,0,0>}
      object{Pod_Ladder_Supports  rotate<0,0,90>}
      object{Pod_Ladder_Supports  rotate<0,0,-90>}
}
#declare Tube_Seam_Indicators=union{
//  box right side
     box{<.2,1.5,-.1><.4,1.6,.1> texture{Steel_beam}}
     box{<.18,1.4,-.12><.42,1.51,.12> texture{goldfoil}}
     sphere{<.25,1.6,0>,.08 texture{Glow_Red}}          // red light
     sphere{<.75,1.6,0>,.08 texture{Glow_Green}}      // green light
// box left side
     box{<-.4,1.5,-.1><-.2,1.6,.1> texture{Steel_beam}}
     box{<-.42,1.4,-.12><-.18,1.51,.12> texture{goldfoil}}
     sphere{<.75,1.6,0>,.08 texture{Glow_Red}}          // red light
     sphere{<.25,1.6,0>,.08 texture{Glow_Green}}      // green light
}
#declare Tube_Seam=union{
     cylinder{<-.1,0,0><.1,0,0>,1.8 texture{Steel_beam}}
//  Indicators
     object{Tube_Seam_Indicators}
     object{Tube_Seam_Indicators rotate<180,0,0>}
//  rivets
     #declare Count=0
     #while (Count<360)
         sphere{<-.1,1.7,0>,.08  rotate<Count,0,0> texture{silver}}
         sphere{<.1,1.7,0>,.08 rotate<Count,0,0> texture{silver}}
         #declare Count=Count+6
     #end
}
#declare ShipFrameLadder=union{
    cylinder{<-50,.5,0><50,.5,0>,0.1 texture{Steel_beam}}
    cylinder{<-50,-.5,0><50,-.5,0>,0.1 texture{Steel_beam}}

     #declare Count=-50
     #while (Count<50)
         cylinder{<Count,-.5,0><Count,.5,0>,0.1 texture{Steel_beam}}
         #declare Count=Count+1
     #end
     #declare Count=-50
     #while (Count<50)
         cylinder{<Count,-.5,0><Count,-.5,1.5>,0.1 texture{Steel_beam}}
         cylinder{<Count,.5,0><Count,.5,1.5>,0.1 texture{Steel_beam}}
         #declare Count=Count+5
     #end
}
#declare ShipFrame=union{
    cylinder{<-51,5,0><51,5,0>,1.5 texture{silver}}
    cylinder{<-51,-5,0><51,-5,0>,1.5 texture{silver}}
// Ladders
     object{ShipFrameLadder translate<0,5,-1.7>}
     object{ShipFrameLadder rotate<0,180,0> translate<0,-5,1.7>}

// End-caps
      object{Hatch translate<0,51,0> rotate<0,0,90> translate<0,5,0>}
      object{Hatch translate<0,51,0> rotate<0,0,90> translate<0,-5,0>}
      object{Hatch translate<0,51,0> rotate<0,0,-90> translate<0,5,0>}
      object{Hatch translate<0,51,0> rotate<0,0,-90> translate<0,-5,0>}

// crossbeams
    #declare Count=-50
    #while (Count<=50)
      object{Girder texture{Steel_beam} rotate<0,0,90> rotate<0,90,0> translate<Count,0,0>}
      object{Tube_Seam translate<Count,5,0>}
      object{Tube_Seam translate<Count,-5,0>}
      #declare Count=Count+20
    #end

// cross tubes / and seams
    #declare Count=-40
    #while (Count<=40)
       cylinder{<Count,-5,0><Count,5,0>,1.5 texture{silver}}
       object{Tube_Seam rotate<0,0,90> translate<Count,0,0>}
       object{Tube_Seam translate<Count-3,5,0>}
       object{Tube_Seam translate<Count-3,-5,0>}
       object{Tube_Seam translate<Count+3,5,0>}
       object{Tube_Seam translate<Count+3,-5,0>}

       #declare Count=Count+20
    #end
}
