//------------------------------------------------------------------------
//
//  spacemen. INC
//
//  Author:  Robert J Becraft
//  Created: March, 1998
//------------------------------------------------------------------------

//----Defines --------------
#declare Helmet=union{
//    difference{
      sphere{<0,-.01,0>,.18 texture{silver}}
//      cylinder{<0,0,.14><0,0,.22>,.2}
//     }
//    cylinder{<0,0,0><0,0,.14>,.13 texture{Steel_beam}}
    cylinder{<0,-.2,0><0,-.1,0>,.15 texture{pigment{color Blue}}}
}
#declare Torso=union{
     cone{<0,0,0>,.225,<0,-.65,0>,.15 texture{Steel_beam}}
     cylinder{<0,-.56,0><0,-.49,0>,.18 texture{goldfoil}}
     sphere{<0,-.58,0>,.18     texture{Steel_beam}}
     box{<-.075,-.3,-.22><.075,-.05,0> texture{Steel_beam}}
  }
#declare Foot=union{
      cylinder{<0,0,0><0,.05,0>,.072 texture{Steel_beam}}
      box{<-.072,0,0><.072,.05,.20> texture{Steel_beam}}
      cylinder{<0,0,.20><0,.05,.20>,.072 texture{Steel_beam}}
}
#declare Hand=union{
    sphere{<0,.055,0>,.05 texture{Steel_beam}}
    cylinder{<-.02,0,0> <.02,0,0>,.050 texture{Steel_beam}}
    cone{<0,0,-.04>,.018 <.0,-.065,-.1>,.015 texture{Steel_beam}}
    cone{<0,-.03,-.015>,.015 <0,-.135,-.02>,.012 texture{Steel_beam}}
    cone{<0,-.03,.015>,.015 <0,-.135,.02>,.012 texture{Steel_beam}}
    cone{<0,-.03,.04>,.015 <0,-.115,.05>,.012 texture{Steel_beam}}
    cone{<0,-.03,-.04>,.015 <0,-.115,-.05>,.012 texture{Steel_beam}}
}
#declare Left_Arm=union{
    sphere{<0,-.05,0>,.1 texture{Steel_beam}}
    cone{<.1,-.30,0>,.06 <0,0,0>,.08 texture{Steel_beam}}
    sphere{<.12,-.33,0>,.07 texture{Yellow_Strip}}
    cone{<.1,-.35,0>,.06 <.1,-.6,0>,.05 texture{Steel_beam}}
    object{Hand translate<.1,-.65,0>}
}
#declare Left_Leg=union{
    cone{<.05,-.30,-.1>,.09 <-.05,.1,0>,.12 texture{Steel_beam}}
    sphere{<.05,-.33,-.12>,.09 texture{Yellow_Strip}}
    cone{<.05,-.35,-.1>,.09 <.05,-.75,-.10>,.07 texture{Steel_beam}}
    object{Foot translate<.045,-.78,-.27>}
}
#declare Right_Arm=union{
    sphere{<0,-.05,0>,.1 texture{Steel_beam}}
    cone{<-.1,-.30,0>,.06 <0,0,0>,.08 texture{Steel_beam}}
    sphere{<-.12,-.33,0>,.07 texture{Yellow_Strip}}
    cone{<-.1,-.35,0>,.06 <-.1,-.6,0>,.05 texture{Steel_beam}}
    object{Hand translate<-.1,-.65,0>}
}
#declare Right_Leg=union{
    cone{<-.05,-.30,-.1>,.09 <.05,.1,0>,.12 texture{Steel_beam}}
    sphere{<-.05,-.33,-.12>,.09 texture{Yellow_Strip}}
    cone{<-.05,-.35,-.1>,.09 <-.05,-.75,-.10>,.07 texture{Steel_beam}}
    object{Foot translate<-.055,-.78, -.27>}
}
#declare Backpack_Frame=difference{
      box{<-.14,-.6,-.05><.14,0,.15> texture{Steel_beam}}
      box{<-.15,-.61,0><.15,-.05,.16>}
     }
#declare Backpack=union{
    object{Backpack_Frame texture{Steel_beam}}
    box{<-.145,-.045,-.055><.145,-.005,.155> texture{silver}}
    cone{<.1,0,.1>,.011 <.1,.5,.1>,.009 texture{silver}}
    cone{<.1,0,.1>,.013 <.1,.1,.1>,.011 texture{Steel_beam}}
    cylinder{<-.1,-.565,.07><-.07,-.05,.07>,.078 texture{silver}}
    cylinder{<.1, -.565,.07>< .07,-.05,.07>,.078 texture{silver}}
    cylinder{<-.1,-.45,.07><-.07,-.40,.07>,.08 texture{Steel_beam}}
    cylinder{<.1, -.45,.07>< .07,-.40,.07>,.08 texture{Steel_beam}}
    cylinder{<-.1,-.25,.07><-.07,-.20,.07>,.08 texture{Steel_beam}}
    cylinder{<.1, -.25,.07>< .07,-.20,.07>,.08 texture{Steel_beam}}
    sphere{<.1,-.565,.07>,.078 texture{silver}}
    sphere{<-.1,-.565,.07>,.078 texture{silver}}
}
#declare Spaceman=union{
   object{Helmet translate<0,1.48,0> texture{silver}}
   object{Torso  translate<0,1.3,0>}
   object{Left_Arm translate<.225,1.3,-.05>}
   object{Left_Leg translate<.1,.65,0>}
   object{Right_Arm translate<-.225,1.3,-.05>}
   object{Right_Leg translate<-.1,.65,0>}
   object{Backpack translate<0,1.4,.22>}
}
#declare SpacemanT=union{
   object{Helmet translate<0,1.48,0> texture{silver}}
   object{Torso  translate<0,1.3,0>}
   object{Left_Arm translate<.225,1.3,-.05>}
   object{Right_Arm translate<-.225,1.3,-.05>}
   object{Backpack translate<0,1.4,.22>}
}

//---- BOT Parts
#declare Bot_Helmet=union{
      sphere{<0,0,0>,.09 texture{silver}}
      cone{<0,-.18,0>,.145 <0,0,0>,.09 texture{silver}}
      cylinder{<0,-.2,0><0,-.15,0>,.15 texture{Green_Strip}}
}
#declare Bot_Pincher=difference{
    cylinder{<-.01,0,0><.01,0,0>,.05 texture{Steel_beam}}
    cylinder{<-.011,0,0><.011,0,0>,.03 }
    box{<-.011,-.051,-.02><.011,.051,.02>}
}
#declare Bot_Arm=union{
    sphere{<0,-.05,0>,.1 texture{Steel_beam}}
    cone{<.1,-.30,0>,.06 <0,0,0>,.08 texture{Steel_beam}}
    sphere{<.12,-.33,0>,.07 texture{Green_Strip}}
    cone{<.1,-.35,0>,.06 <.1,-.6,0>,.05 texture{Steel_beam}}
    sphere{<.1,-.65,0>,.05 texture{silver}}    
    object{Bot_Pincher translate<.1,-.69,0>}
}
#declare Bot_Engin=difference{
   union{
    cylinder{<0,0,0><0,-.2,0>,.05 texture{silver}}
    sphere{<0,-.3,0>,.1 texture{silver}}
    cone{<0,-.3,0>,.1 <0,-.5,0>,.15 texture{silver}}
   }
   cone{<0,-.3,0>,.08 <0,-.51,0>,.13 }
}
#declare Bot_Torso=union{
     cone{<0,0,0>,.225,<0,-.65,0>,.15 texture{silver}}
     cylinder{<0,0,0><0,-.05,0>,.225 texture{Steel_beam}}
     cylinder{<0,-.56,0><0,-.49,0>,.18 texture{goldfoil}}
     sphere{<0,-.56,0>,.18     texture{silver}}
     #declare Count=0
     #while (Count<360)
       sphere{<0,-.61,.16>,.02 texture{silver} rotate<0,Count,0>}
       sphere{<0,-.025,.225>,.01 texture{silver} rotate<0,Count,0>}
       #declare Count=Count+8
     #end
}
#declare Bot=union{
   object{Bot_Helmet translate<0,1.48,0> texture{silver}}
   object{Bot_Torso  translate<0,1.3,0>}
   object{Backpack translate<0,1.4,.22>}
   object{Bot_Arm translate<.225,1.3,-.05>}
   object{Bot_Arm rotate<0,180,0> translate<-.225,1.3,-.05>}
   object{Bot_Engin translate<0,.7,0>}
}

